/***************************************************************************
                          kdddlldlg.h  -  description                              
                             -------------------                                         

    version              : 0.1pre-alpha
    begin                : Thu Feb 25 05:55:16 CET 1999
                                           
    copyright            : (C) 1999 by Uwe Bhme                         
    email                : uwe@hof.baynet.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef KDDDLLDLG_H
#define KDDDLLDLG_H

#include <qdialog.h>
#include <qtextstream.h>

#include "kdddllparser.h"
#include "typelayout.h"


/** This class provides dynamical output for a dialog defined in a KDDL file.
  * @author Uwe Bhme
  */

class KDDDLLDlg :
    public QDialog
{
    Q_OBJECT

public:
    /** Constructor for the dialog.
      *
      * @param KDDDLLTagList The tag list to be displayed.
      * @param parent   You know from QWidget.
      * @param name     You know from QWidget.
      */
    KDDDLLDlg( KDDDLLTagList *tagList, QWidget* parent = 0, const char *name = 0 );
    ~KDDDLLDlg();

protected:
    /** The great KTypeLayout object from
      * <A HREF="mailto:rich@kde.org">Richard J. Moore</A> ?.
      */
    KTypeLayout   *ktl;

    /** Does the actual adding of the widgets to the dialog.
      */
    void          tagToLayout( KDDDLLTagList *tagList );
};

#endif
